Subject: Re: [PATCH 2/7] net: add FCoE offload support through net_device

From: Stephen Hemminger <[email-masked]>
Date: Fri, 20 Feb 2009 15:27:44 -0800

On Fri, 20 Feb 2009 15:21:42 -0800
"Zou, Yi" <[email-masked]> wrote:

> >>On Thu, 19 Feb 2009 12:49:49 -0700
> >>Yi Zou <[email-masked]> wrote:
> >>
> >>> This adds a "struct net_fcoe_ops *fcoe_ops" to net_device struct so
> >>any
> >>> network adapter driver can provide Fiber Channle over Ethernet (FCoE)
> >>offload
> >>> support through net_device. The fcoe_ops is only available when FCoE
> >>is
> >>> enabled in kernel as built-in or module driver.
> >>>
> >>> Signed-off-by: Yi Zou <[email-masked]>
> >>
> >>Rather than adding another _ops structure please add to existing
> >>netdevice_ops. You don't need the flags that way. If netdevice_ops
> >>has fcoe_setup, then device can do it...
> >The comments in struct net_device_ops says for management hooks, if
> >that's an ok place for net_fcoe_ops, then, I am all for it.
> >
> >Thanks.
> >
> >yi
> 
> Hi, Stephen,
> Regarding your comment about adding net_fcoe_ops to net_device_ops,
> the net_fcoe_ops contains function pointers ad well as data members,
> where net_device_ops seems to me is the placeholder only for function
> pointers. So I think it is still better to still leave
> the net_fcoe_ops to net_device. Let me know what you think.
> 
> Thanks,
> yi

Data members go in net_device (because they are per device instance).
Put fcoe stuff in net_device_ops.  Ideally, it should look like TSO
and GRO; with standard ethtool type config?